
from interfaces.msg import HapticSignal as HapticSignalMsg

HEIGHT = 192

SIGNAL_MAP = {
    'target': lambda x: f'<t,{x}>',
    "found": '<D>',
    "right": '<r>',
    "left": '<l>',
    "forward": '<f>',
    'stop': lambda x: f'<O,{x}>',
    "arrived": '<A>',
    "empty": '<None>',
}

LONG_TERM_IDLE_TIMEOUT = 20
SHORT_TERM_IDLE_TIMEOUT = 4
IDLE_THRESHOLD = 0.1

SINGAL_INTENSITY_RANGE = [50.0, 100.0]
MAX_SIGNAL_FREQUENCY = 4  # Highest Frequency between pairs of signals In seconds
# SIGNAL_PERIOD = 1 / SIGNAL_FREQUENCY
MAX_SIGNAL_HALT = 0.8 # Longest Possible Time between signals In seconds

OBS_DIST_TOO_CLOSE_SCREEN_RATIO = 0.15
OBS_HALT_QUICKEN_MULTIPLIER = 0.2
class HapticSignal:
    signal: str
    delay: float
    intensity: float
    
    def __init__(
        self, 
        signal, 
        intensity=SINGAL_INTENSITY_RANGE[0], 
        delay=0.0,
    ):
        self.signal = signal
        self.intensity = intensity
        self.delay = delay
        
    def __repr__(self) -> str:
        return f'{self.signal}'
    def __str__(self) -> str:
        return f'{self.signal}'
    def msg(self) -> HapticSignalMsg:
        return HapticSignalMsg(
            signal=self.signal,
            intensity=self.intensity,
            delay=self.delay,
        )

        
NEW_SIGALS={
    'forward': lambda x: [
        HapticSignal(SIGNAL_MAP['left']),
        HapticSignal(SIGNAL_MAP['right'], delay=1/x),
    ],
    'dir_left': lambda x: [
        HapticSignal(SIGNAL_MAP['left']),
        HapticSignal(SIGNAL_MAP['left'], delay=1/x),
    ],
    'dir_right': lambda x: [
        HapticSignal(SIGNAL_MAP['right']),
        HapticSignal(SIGNAL_MAP['right'], delay=1/x),
    ],        
    'obs_stop': lambda x: [
        HapticSignal(SIGNAL_MAP['stop'](0), intensity=x),
        HapticSignal(SIGNAL_MAP['stop'](1), intensity=x),
    ],    
}
